module lhapdf
  implicit none
  save
  character*272 :: lhaname
  integer :: lhaset, lhamemb
end module lhapdf


module lhasets
  implicit none
  save
  include 'parmsetup.inc'
  character*272, dimension(nmxset) :: lhanames
  integer, dimension(nmxset) :: lhanumbers, lhamembers
  integer :: nsets = 0
end module lhasets


module lhapdfc
  implicit none
  save
  character*232 :: lhapath = 'pdfsets'
end module lhapdfc


module lhacontrol
  implicit none
  save
  character*20, dimension(20) :: lhaparm = ' '
  double precision, dimension(20) :: lhavalue = 0.0d0
end module lhacontrol


module lhaglsta
  implicit none
  save
  double precision :: xminnum = 0.0d0, xmaxnum = 0.0d0, &
       q2minnum = 0.0d0, q2maxnum = 0.0d0, totnum = 0.0d0, &
       xminnup = 0.0d0, xmaxnup = 0.0d0, q2minnup = 0.0d0, &
       q2maxnup = 0.0d0, totnup = 0.0d0
end module lhaglsta
